﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.86
@EndOfDesignText@

Sub Class_Globals
	#If B4J
	Private fx As JFX
	#End if
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private lblHello As B4XView
	Private AppDashUI2 As AppDashUIstyle2
	Private Drawer As B4XDrawer  'code generated
	Private HamburgerIcon As B4XBitmap  'code generated
	Private iv As ImageView  'code generated
	Private imgvwBG As B4XView 'at layout
	Private AppPanel As B4XView 'at layout
	Private cbxTheme As B4XComboBox
	Private cbxTheme As B4XComboBox
	Private cbxStyle As B4XComboBox
End Sub

Public Sub Initialize
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	If AppDashUIcodes.recentPageID = "" Then AppDashUIcodes.recentPageID = "MainPage"
	UIThemes.ApplyTheme(Me, UIThemes.frmTheme)
	UIThemes.ApplyStyle(Me, UIThemes.frmStyle)
	Log("AppDashUI1 B4XPage_Created / AppDashUIcodes.recentPageID: " & AppDashUIcodes.recentPageID & " / " & UIThemes.frmTheme & ", " & UIThemes.frmStyle )
	Root = Root1
	AppDashUIcodes.InitializeFormUtils(Me)
	B4XPages.SetTitle(Me, "AppDashUI Dashboard")
	LoadDrawer
	AppDashUI2 = B4XPages.GetPage("AppDashUI 2")
	AppDashUIcodes.LoadPageSettings("AppDashUI 1", "AppDashUI 1 B4XPage_Created")
End Sub

Private Sub B4XPage_Appear
	UIThemes.ApplyTheme(Me, UIThemes.frmTheme)
	UIThemes.ApplyStyle(Me, UIThemes.frmStyle)
	Log("AppDashUI1 B4XPage_Appear / AppDashUIcodes.recentPageID: " & AppDashUIcodes.recentPageID & " / " & UIThemes.frmTheme & ", " & UIThemes.frmStyle )
	lblHello.Text = $"Hello ${B4XPages.MainPage.txtUser.Text}!"$
	HideDrawer
	MainFormFocus (True)
	#if B4A
	Sleep(0)
	B4XPages.GetManager.ActionBar.RunMethod("setDisplayHomeAsUpEnabled", Array(True))
	Dim bd As BitmapDrawable
	bd.Initialize(HamburgerIcon)
	B4XPages.GetManager.ActionBar.RunMethod("setHomeAsUpIndicator", Array(bd))
	#End If
	AppDashUIcodes.UpdateImageVwFrmCvs(imgvwBG)
	AppDashUIcodes.LoadPageSettings("AppDashUI 1", "AppDashUI 1 B4XPage_Appear")
End Sub

Private Sub B4XPage_Disappear
	#If B4J
	AppDashUIcodes.recentPageID = "AppDashUI 1"
	AppDashUIcodes.SavePageSettings(AppDashUIcodes.recentPageID)
	#End If

	#If B4A Or B4i
	B4XPages.GetManager.ActionBar.RunMethod("setHomeAsUpIndicator", Array(0))
	#End If
End Sub

Private Sub LoadDrawer
	Drawer.Initialize(Me, "Drawer", Root, 300dip)
	Drawer.CenterPanel.LoadLayout("AppDashUIpage1")
	Drawer.LeftPanel.LoadLayout("DrawerLeft")
	AppDashUI2 = B4XPages.GetPage("AppDashUI 2")
	HamburgerIcon = xui.LoadBitmapResize(File.DirAssets, "hamburger.png", 32dip, 32dip, True)
	#If B4J
	iv.Initialize("imgHamburger")
	iv.SetImage(HamburgerIcon)
	Drawer.CenterPanel.AddView(iv, 2dip, 2dip, 32dip, 32dip)
	iv.PickOnBounds = True
	#Else If B4A
	iv.Initialize("imgHamburger")
	iv.Bitmap = HamburgerIcon
	Drawer.CenterPanel.AddView(iv, 2dip, 2dip, 32dip, 32dip)
	#End if
	#If B4i
	Dim bb As BarButton
	bb.InitializeBitmap(HamburgerIcon, "hamburger")
	B4XPages.GetNativeParent(Me).TopLeftButtons = Array(bb)
	#End if
	
	PopulateThemeCbx
	PopulateStyleCbx
	
End Sub

Private Sub PopulateThemeCbx
	Dim Items As List
	Items.Initialize
	Items.AddAll(Array As String("Select App Theme", "Dark", "Modena", "Silver", "Mac", "Bee", "Breeze"))
	cbxTheme.SetItems(Items)
	cbxTheme.DelayBeforeChangeEvent = 0
End Sub

Private Sub PopulateStyleCbx
	Dim Items As List
	Items.Initialize
	Items.AddAll(Array As String("Select App Style", "Transparent", "Decorated", "Undecorated", "Utility"))
	cbxStyle.SetItems(Items)
	cbxStyle.DelayBeforeChangeEvent = 0
End Sub

Sub HideDrawer
	Drawer.LeftOpen = False
End Sub

Sub MainFormFocus (HasFocus As Boolean)
	Try
		If HasFocus Then
			HamburgerIcon = xui.LoadBitmapResize(File.DirAssets, "hamburger.png", 32dip, 32dip, True)
		Else
			HamburgerIcon = xui.LoadBitmapResize(File.DirAssets, "hamburger-grey.png", 32dip, 32dip, True)
		End If
		iv.SetImage(HamburgerIcon)
	Catch
		Log("Error loading HamburgerIcon in main form")
	End Try
End Sub

Private Sub B4XPage_MouseExited (EventData As MouseEvent)
	MainFormFocus(False)
End Sub

Private Sub B4XPage_MouseEntered (EventData As MouseEvent)
	MainFormFocus(True)'
	Log("Mouse at X = " & EventData.X & " | Y = " &  EventData.Y)

End Sub

Private Sub B4XPage_Resize (Width As Int, Height As Int)
	Drawer.Resize(Width, Height)
End Sub

#if B4J
Private Sub imgHamburger_MouseClicked (EventData As MouseEvent)
	Drawer.LeftOpen = True
End Sub
#else if B4i
Private Sub B4XPage_MenuClick (Tag As String)
	If Tag = "hamburger" Then
		Drawer.LeftOpen = Not(Drawer.LeftOpen)
	End If
End Sub
#end if
#If B4A
Private Sub imgHamburger_Click
	B4XPages.MainPage.Drawer.LeftOpen = True
End Sub
#End if

Private Sub B4XPage_Background

End Sub

Private Sub B4XPage_CloseRequest As ResumableSub
	#If B4J
	AppDashUIcodes.recentPageID = "AppDashUI 1"
	AppDashUIcodes.SavePageSettings(AppDashUIcodes.recentPageID)
	#End If

	#If B4A Or B4i
	'home button
	If Main.ActionBarHomeClicked Then
		B4XPages.MainPage.Drawer.LeftOpen = Not(B4XPages.MainPage.Drawer.LeftOpen)
		Return False
	End If
	'back key
	If B4XPages.MainPage.Drawer.LeftOpen Then
		B4XPages.MainPage.Drawer.LeftOpen = False
		Return False
	End If
	#End If
	Return True
End Sub

Private Sub btnDraw_Click
	AppDashUIcodes.recentPageID = "AppDashUI 1"
	B4XPages.ShowPageAndRemovePreviousPages("AppDashUI 2")
End Sub

Private Sub btnSignOut_Click
	AppDashUIcodes.recentPageID = "AppDashUI 1"
	AppDashUIcodes.SavePageSettings(AppDashUIcodes.recentPageID)
	HideDrawer
'	AppDashUI2.ClearImage
	B4XPages.ShowPageAndRemovePreviousPages("MainPage")
End Sub

Private Sub RestartApp (FilePath As String, filename As String)
	fx.ShowExternalDocument(File.GetUri(FilePath, filename))
	Sleep(2500)
	CallSubDelayed(Me, "RestartApp_Complete")
End Sub

Private Sub SaveUpdatedTheme
	AppDashUIcodes.recentPageID = "AppDashUI 1"
	AppDashUIcodes.SavePageSettings(AppDashUIcodes.recentPageID)
	HideDrawer
'	AppDashUI2.ClearImage
	AppDashUIcodes.UpdateImageVwFrmCvs(imgvwBG)
End Sub

Private Sub SaveUpdatedStyle
	AppDashUIcodes.recentPageID = "AppDashUI 1"
	AppDashUIcodes.SavePageSettings(AppDashUIcodes.recentPageID)
	HideDrawer
'	AppDashUI2.ClearImage
	AppDashUIcodes.UpdateImageVwFrmCvs(imgvwBG)

	Dim execpath As String = "C:\Users\AppDashUI\B4J\Objects\temp\build"
	RestartApplication(execpath, "B4JProject.exe")
End Sub

Private Sub RestartApplication (FilePath As String, filename As String)
	Try
		Dim sf As Object = xui.Msgbox2Async("Changing window form style requires restart.Save your data before continuing.", "AppDashUI - Change Style", "OK", "Cancel", "", Null)
		Wait For (sf) Msgbox_Result (Result As Int)
		If Result = xui.DialogResponse_Positive Then
			RestartApp (FilePath, filename)
			Wait For RestartApp_Complete
			ExitApplication
		End If
	Catch
		Log(LastException)
	End Try
End Sub


'seems unused
#If B4J
Private Sub DrawerMenu_MouseClicked (EventData As MouseEvent)
	HideDrawer
End Sub
#Else if B4A
Private Sub DrawerMenu_Click
	B4XPages.MainPage.Drawer.LeftOpen = Not(B4XPages.MainPage.Drawer.LeftOpen)
End Sub
#End if

Private Sub SetMoveListener (Form As JavaObject)
	Dim Stage As JavaObject = Form.GetField("stage")
	Dim XProp As JavaObject = Stage.RunMethod("xProperty",Null)
	Dim YProp As JavaObject = Stage.RunMethod("yProperty",Null)
  
	Dim O As Object = Form.CreateEventFromUI("javafx.beans.value.ChangeListener","FormMoved",Null)
	XProp.RunMethod("addListener",Array(O))
	YProp.RunMethod("addListener",Array(O))
End Sub

Private Sub FormMoved_Event (MethodName As String, Args() As Object) As Object
	Dim F As Form = Sender
	Log("Form moved to x/left:y/top " & F.WindowLeft & " : " & F.WindowTop)
End Sub

Private Sub AppPanel_MousePressed (EventData As MouseEvent)
	AppDashUIcodes.MousePressed (Me, EventData)
End Sub

Private Sub AppPanel_MouseDragged (EventData As MouseEvent)
	AppDashUIcodes.MouseDragged (Me, EventData)
End Sub

Private Sub lblHello_MousePressed (EventData As MouseEvent)
	AppDashUIcodes.MousePressed (Me, EventData)
End Sub

Private Sub lblHello_MouseDragged (EventData As MouseEvent)
	AppDashUIcodes.MouseDragged (Me, EventData)
End Sub

Private Sub WithInRange(testnum As Int, minval As Int, maxval As Int) As Boolean
	Dim test As Boolean
	If testnum >= minval And testnum <= maxval Then
		test = True
		Else
			test = False
	End If
	Return test
End Sub

Private Sub cbxTheme_SelectedIndexChanged (Index As Int)
	'Options: 1-"Dark", 2-"Modena", 3-"Silver", 4-"Mac", 5-"Bee", 6-"Breeze"
	If WithInRange(cbxTheme.SelectedIndex, 1, 6)  Then
		UIThemes.frmTheme = cbxTheme.GetItem(cbxTheme.SelectedIndex)
		UIThemes.ApplyTheme(Me, UIThemes.frmTheme)
		SaveUpdatedTheme
		DrawerAtDefault
		Log("AppDashUI1 ApplyTheme / AppDashUIcodes.recentPageID: " & AppDashUIcodes.recentPageID & " / " & UIThemes.frmTheme)
	End If
End Sub

Private Sub cbxStyle_SelectedIndexChanged (Index As Int)
	'Style: 1-"TRANSPARENT", 2-"DECORATED", 3-"UNDECORATED", 4-"UTILITY"
	If WithInRange(cbxStyle.SelectedIndex, 1, 4)  Then
		UIThemes.frmStyle = cbxStyle.GetItem(cbxStyle.SelectedIndex)
		UIThemes.ApplyStyle(Me, UIThemes.frmStyle)
		SaveUpdatedStyle
		DrawerAtDefault
		Log("AppDashUI1 ApplyStyle / AppDashUIcodes.recentPageID: " & AppDashUIcodes.recentPageID & " / " & UIThemes.frmStyle )
	End If
End Sub

Private Sub DrawerAtDefault
	cbxTheme.SelectedIndex = 0
	cbxStyle.SelectedIndex = 0
End Sub